using System;
using System.Collections.Generic;
using System.Text;
using KorenTec.Messaging.Msmq;
using KorenTec.Messaging;
using System.Collections;
using System.Threading;
using AsynchronousCommunication;
using Messages;
using KorenTec.Messages;

namespace ClientRunner
{
    class Program
    {
        static void Main(string[] args)
        {
            log4net.LogManager.GetLogger("hello").Debug("Started.");
            ObjectBuilder.SpringFramework.Builder builder = new ObjectBuilder.SpringFramework.Builder();
            IBus bClient = builder.Build<IBus>();

            bClient.Start();

            bClient.Subscribe(
                typeof(EntitiesUpdatedMessage<IntInfo>),
                (Predicate<IMessage>)delegate(IMessage msg)
                {
                    EntitiesUpdatedMessage<IntInfo> toHandle = msg as EntitiesUpdatedMessage<IntInfo>;
                    if (toHandle != null)
                        return (toHandle.Updates[0].Info.k > 50);

                    return false;
                }
            );

            int toSend = 1;
            while (Console.ReadLine() == string.Empty)
            {
                Messages.Command m = new Messages.Command();
                m.i = toSend;
                ArrayList strings = new ArrayList(100);
                for (int i = 0; i < 100; i++)
                    strings.Add(Guid.NewGuid().ToString());

                m.alotofdata = strings.ToArray(typeof(string)) as string[];

                toSend++;

                AddMessage<IntInfo> addMessage = new AddMessage<IntInfo>();
                addMessage.Info = new IntInfo();
                addMessage.Info.k = toSend;


                //bClient.Send(new IMessage[] { m, addMessage }, new CompletionCallback(Callback), m);
                bClient.Send(new IMessage[] { m, addMessage }, new CompletionCallback(Callback), m);

                Console.WriteLine("Sent: {0}.{1}  {2}", DateTime.Now.Second, DateTime.Now.Millisecond, m.i);

                bClient.Send(addMessage);
            }

            bClient.Unsubscribe(typeof(EntitiesUpdatedMessage<IntInfo>));
        }

        private static void Callback(int errorCode, object state)
        {
            Messages.Command cmd = ((Messages.Command)state);

            if (cmd.i % 100 == 0)
            {
                int j = errorCode + cmd.i;
                Console.WriteLine("Callback: {0}.{1}  {2}",
                    DateTime.Now.Second,
                    DateTime.Now.Millisecond,
                    j);
            }
        }
    }
}
